#!/bin/sh
set -e
set -x

if [ "$#" -lt 2 ]; then
    echo 'Need two arguments: old server IP, and service name.'
    false
fi
if [ ! "$2" = "pleroma" ] && [ ! "$2" = "peertube" ]; then
    echo "Need legal service name (pleroma or peertube)."
    false
fi
server_ip="$1"
app="$2"
if [ "${app}" = "pleroma" ]; then
    db_name="pleroma"
    dirs="/var/lib/pleroma/uploads /etc/pleroma"
elif [ "${app}" = "peertube" ]; then
    db_name="peertube_prod"
    dirs="/var/www/peertube/storage /var/www/peertube/config"
fi

config_tree_prefix="${HOME}/config/buster"
setup_scripts_dir="${config_tree_prefix}/setup_scripts"

cd "${setup_scripts_dir}"
./prepare_to_meet_server.sh "${server_ip}"
read -p'Hit Enter when you are done.' ignore
eval $(ssh-agent) && ssh-add
echo 'Enter password for root on target server next.'
ssh plom@"${server_ip}" "su -lc \"cd config/buster/setup_scripts && git pull && ./backup_app.sh ${app} ${db_name} ${dirs}\""
scp plom@"${server_ip}":~/${app}_backup.tar /home/plom/${app}_backup.tar
./restore_app.sh "${app}" "${db_name}"
